//======================================================================
// File:		bittableitem.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef BITTABLEITEM_HH
#define BITTABLEITEM_HH

#include <qtable.h>

class BitTableItem : public QTableItem
{
public:
  BitTableItem( QTable *, const QString & );
  virtual ~BitTableItem();

  bool isChecked() const { return m_isOn; }
  void setChecked( bool on );
  
  QSize sizeHint() const;
  
protected:
  bool m_isOn;
  
  void paint( QPainter *, const QColorGroup &, const QRect &, bool selected );

};

inline void
BitTableItem::setChecked( bool on )
{
  m_isOn = on; 
  table()->updateCell( row(), col() );  
}

#endif // BITTABLEITEM_HH
