//======================================================================
// File:		breadboardpartpin.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef BREADBOARDPARTPIN_HH
#define BREADBOARDPARTPIN_HH

class QPixmap;
class QPainter;

class BreadBoardPartPin
{
public:
  enum Orientation
  {
    ConnectRight=0,
    ConnectBottom,
    ConnectLeft,
    ConnectTop
  };
  
  enum Status
  {
    Unused=0,
    Used,
    Input,
    Output
  };
    
  BreadBoardPartPin( int no, int x, int y, Orientation, const QString & name );
  ~BreadBoardPartPin();
      
  void setStatus( Status );
  
  void paint( QPainter * );

  bool hit( const QPoint & );
  int  pinNumber() const { return m_pinNumber; }
  
  QString name() const { return m_name; }
  
protected:
  QPoint      m_pos;
  Orientation m_orientation;
  Status      m_status;
  QString     m_name;
  int         m_pinNumber;
  
  static QPixmap *s_input[4];
  static QPixmap *s_output[4];
  static QPixmap *s_used[4];
  static QPixmap *s_unused[4];
  
};


#endif // BREADBOARDPARTPIN_HH
