//======================================================================
// File:		breadboardview.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <qbuttongroup.h>
#include <qlabel.h>
#include <qpushbutton.h>

#include <breadboardview.h>
#include <breadboard.h>
#include <pic.h>

BreadBoardView::BreadBoardView( QWidget *parent, const char *name ) :
  UIBreadBoardView( parent, name ),
  m_pic( 0 )
{
  connect( ui_toolbar, SIGNAL( clicked( int ) ),
           this, SLOT( setModeSLOT( int ) ));
}

BreadBoardView::~BreadBoardView()
{
}

void
BreadBoardView::setPic( Pic *pic )
{
  m_pic = pic;
  
  ui_breadBoard->setPic( pic );
  refreshSLOT();
}

void
BreadBoardView::refreshSLOT()
{
  ui_breadBoard->refreshSLOT();
}

void
BreadBoardView::setModeSLOT( int mode )
{
  ui_breadBoard->setModeSLOT( (BreadBoard::Mode)mode );
}
