//======================================================================
// File:		breakcondition.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef BREAKCONDITION_HH
#define BREAKCONDITION_HH

#include <qstring.h>

class PicRAM;
class PicRegister;

class BreakCondition
{
public:
  enum Mode
  {
    Always=0,
    Equal,
    NotEqual,
    GreaterThan,
    GreaterOrEqual,
    LessThan,
    LessOrEqual,
    And
  };
  
  BreakCondition( PicRAM * );
  ~BreakCondition();

  void setParameter( int addr, BreakCondition::Mode mode, int compare );  
  bool match() const;

  PicRAM *ram() const { return m_ram; }
  
  BreakCondition::Mode mode() const { return m_mode; }
  
protected:
  PicRAM      *m_ram;
  PicRegister *m_reg;
  int          m_compareValue;
  Mode         m_mode;
  
};

#endif // BREAKCONDITION_HH
