//======================================================================
// File:		breakpoint.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef BREAKPOINT_HH
#define BREAKPOINT_HH

#include <breakcondition.h>

class PicRAM;

class Breakpoint
{
public:
  Breakpoint( PicRAM * );
  ~Breakpoint();
  
  bool isEnabled() const { return m_enabled; }
  void setEnabled( bool enabled ) { m_enabled = enabled; }
  
  bool match() const;
  bool isConditional() const;
  bool isTemporary() const { return m_temporary; }
  void setTemporary() { m_temporary = true; }
  
  int address() const { return m_address; }
  
  BreakCondition *condition() const { return m_condition; }
  
protected:
  bool             m_enabled;
  int              m_address;
  BreakCondition  *m_condition;
  bool             m_temporary;
  
};

inline bool
Breakpoint::isConditional() const
{ 
  return (m_condition->mode() != BreakCondition::Always); 
}

inline bool
Breakpoint::match() const
{
  return m_condition->match();
}

#endif // BREAKPOINT_HH
