//======================================================================
// File:		breakpointpixmapitem.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <qpainter.h>

#include <breakpointpixmapitem.h>

BreakpointPixmapItem::BreakpointPixmapItem( QTable *table, Breakpoint *bp ) :
  QTableItem( table, QTableItem::Never, label ),
  m_bp( bp )
{  
  m_bpPix   = new QPixmap((const char **)bp_xpm);
  m_ibpPix  = new QPixmap((const char **)ibp_xpm);
  m_cbpPix  = new QPixmap((const char **)cbp_xpm);
  m_icbpPix = new QPixmap((const char **)icbp_xpm);
}

BreakpointPixmapItem::~BreakpointPixmapItem()
{
}

void
BreakpointPixmapItem::paint( QPainter *p, const QColorGroup & cg, 
                             const QRect & rect, bool )
{
  const QRect cr( 0, 0, rect.width(), rect.height() );

  p->fillRect( cr, row() & 1 ? cg.base().dark( 105 ) : cg.base() );
  
  p->drawText( 2, 0, rect.width()-4, rect.height(), 
               m_flags, text() );
}
