//======================================================================
// File:		breakpointview.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef BREAKPOINTVIEW_HH
#define BREAKPOINTVIEW_HH

#include <qptrlist.h>

#include <uibreakpointview.h>
#include <picregister.h>

class QPixmap;
class Pic;
class Breakpoint;

class BreakpointView : public UIBreakpointView
{
  Q_OBJECT
public:
  BreakpointView( QWidget *parent=0, const char *name=0 );
  virtual ~BreakpointView();

  void setPic( Pic * );
  void setEditable( bool );
    
signals:
  void changedBreakpoint( int );

public slots:
  void newBreakpointSLOT( int );
  void removeBreakpointSLOT( int );
  void changedBreakpointSLOT( int );
  
protected:
  Pic             *m_pic;
  QPixmap         *m_bpPix;             
  QPixmap         *m_ibpPix;            
  QPixmap         *m_cbpPix;             
  QPixmap         *m_icbpPix;            

  void setPixmap( Breakpoint *bp, int row );
  
protected slots:
  void clickedSLOT( int row, int col, int button, const QPoint & mousePos );
  void valueChangedSLOT( int row, int col );
  
};

#endif // BREAKPOINTVIEW_HH
