//======================================================================
// File:		coff.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef COFF_HH
#define COFF_HH

#define F_RELFLG  0x0001
#define F_EXEC    0x0002
#define F_LNNO    0x0004
#define L_SYMS    0x0080
#define F_GENERIC 0x8000

#define STYP_TEXT     0x00020
#define STYP_DATA     0x00040
#define STYP_BSS      0x00080
#define STYP_DATA_ROM 0x00100
#define STYP_ABS      0x01000
#define STYP_SHARED   0x02000
#define STYP_OVERLAY  0x04000
#define STYP_ACCESS   0x08000
#define STYPE_ACTREC  0x10000

#define SYMNMLEN 8

typedef struct filehdr
{
  unsigned short f_magic;
  unsigned short f_nscns;
  unsigned long  f_timdat;
  unsigned long  f_symptr;
  unsigned long  f_nsyms;
  unsigned short f_opthdr;
  unsigned short f_flags;
} filehdr_t;
  
typedef struct opthdr
{
  unsigned short magic;
  unsigned short vstamp;
  unsigned long  proc_type;
  unsigned long  rom_width_bits;  
  unsigned long  ram_width_bits;
} opthdr_t;

typedef struct scnhdr
{
  union
  {
    char _s_name[8];
    struct
    {
      unsigned long _s_zeroes;
      unsigned long _s_offset;
    } _s_s;
  } _s;
  
  unsigned long  s_paddr;
  unsigned long  s_vaddr;
  unsigned long  s_size;
  unsigned long  s_scnptr;
  unsigned long  s_relptr;
  unsigned long  s_lnnoptr;
  unsigned short s_nreloc;
  unsigned short s_nlnno;
  unsigned long  s_sflags;
} scnhdr_t;

typedef struct reloc
{
  unsigned long  r_vaddr;
  unsigned long  r_symndx;
  short          r_offset;
  unsigned short r_type;
} reloc_t;

struct syment
{
  union
  {
    char _n_name[SYMNMLEN];
    struct
    {
      unsigned long _n_zeroes;
      unsigned long _n_offset;
    } _n_n;
    char *_n_nptr[2];
  } _n;
  
  unsigned long  n_value;
  short          n_scnum;
  unsigned short n_type;
  char           n_sclass;
  char           n_numaux;
}



#endif // COFF_HH
