//======================================================================
// File:		conditionbase.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef CONDITIONBASE_HH
#define CONDITIONBASE_HH

#include <qstring.h>

class ConditionBase
{
public:
  ConditionBase();
  ~ConditionBase();

protected:  
  bool isCondition( const QChar & c );
  bool isHexNumber( const QChar & c );  
  void skipWhiteSpace( QString *str, unsigned *pos );

};

inline void
ConditionBase::skipWhiteSpace( QString *str, unsigned *pos )
{
  while ((*pos) < str->length() && str->constref((*pos)).isSpace()) ++(*pos);
}

#endif // CONDITIONBASE_HH
