//======================================================================
// File:		cpuview.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef CPUVIEW_HH
#define CPUVIEW_HH

#include <uicpuview.h>

#include <pic.h>

class CPUView : public UICPUView
{
  Q_OBJECT
public:
  CPUView( QWidget *parent=0, const char *name=0 );
  virtual ~CPUView();
  
  void setPic( Pic *pic );
  
  void setEditable( bool );
  
signals:
  void registerChanged( PicRegister * );

public slots:
  void refreshSLOT();
  void show();
  
protected:
  Pic         *m_pic;
  PicRegister *m_register[128*4];
  int          m_lastValue[128*4];
  int          m_registerCnt;
  bool         m_editable;
  
  QString m_unitStr[3];
  
  void setValue( int row, int value );
  void updateRow( int row );
  
protected slots:
  void valueChangedSLOT( int, int );
  void clickedSLOT( int row, int col, int but, const QPoint & );
  void clockSpeedChangedSLOT( const QString & );
  
};

#endif // CPUVIEW_HH
