//======================================================================
// File:		dectableitem.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <qpainter.h>
#include <qlineedit.h>
#include <qvalidator.h>
#include <qregexp.h>

#include <dectableitem.h>
#include <picregister.h>
#include <stringconversion.h>

#include <iostream>

DecTableItem::DecTableItem( QTable *table, PicRegister *reg, 
                            QTableItem::EditType editType ) :
  PicTableItem( table, reg, editType )
{
  update();
}

DecTableItem::~DecTableItem()
{
}

void
DecTableItem::update()
{
  setText( StringConversion::decString( m_reg->valuePic() ) );
}

QWidget  *
DecTableItem::createEditor() const
{
  QLineEdit *edit = new QLineEdit( table()->viewport() );
  edit->setText( text() );
  
  QRegExpValidator *validator = 
        new QRegExpValidator( QRegExp( "[0-9]*" ), edit );
  
  edit->setValidator( validator );
  edit->setMaxLength( 3 );
  
  return edit;
}

void 
DecTableItem::setContentFromEditor( QWidget * w )
{
  QLineEdit *edit = dynamic_cast<QLineEdit *> (w);
  
  if (edit)
  {
    setValue( edit->text().toInt() );
    update();
  }
}
