//======================================================================
// File:		dil.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <qpainter.h>

#include <dil.h>

DIL::DIL( int numPins, const QString & name ) :
  BreadBoardPart( name ),
  m_numPins( numPins )
{
  m_rect = QRect( 0, 0, 12*16, (numPins/2)*32+16 );
}

DIL::~DIL()
{
}

void
DIL::paint( QPainter *p )
{
  p->save();
  
  p->fillRect( 0, 0, rect().width(), rect().height(), Qt::white );
  
//  p->fillRect( 0, 0, 16, rect().height(), Qt::white );
//  p->fillRect( rect().width()-16, 0, 16, rect().height(), Qt::white );
  
  if (selected())
  {
    p->setPen( Qt::red );
  }
  else
  {
    p->setPen( Qt::black );
  }
  
  //p->setBrush( Qt::white );
  p->drawRect( 16, 0, rect().width()-32, rect().height() );
  p->drawRect( 17, 1, rect().width()-34, rect().height()-2 );
  
  p->drawArc( rect().width()/2-10, -10, 20, 20, 180*16, 180*16 );
   
/*  for (int i=0; i<m_numPins/2; ++i)
  {
    p->drawText( 20, 16+32*i, 200, 16, 
                 AlignLeft | AlignVCenter, m_pin[i]->name() );
    p->drawText( rect().width()-20-200, 16+32*i, 200, 16, 
                 AlignRight | AlignVCenter, m_pinName[17-i] );
  }*/
  
  p->rotate( -90 );
  p->setFont( QFont( "helvetica", 16 ) );
  p->drawText( -rect().height(), 0, rect().height(), rect().width(), 
               AlignCenter, name() );
  
  p->restore();
  
  drawPins( p );
}

void
DIL::setPinName( int i, const QString & name ) 
{ 
  if (i<m_numPins/2)
  {
    addPin( i, 0, 16+32*i, BreadBoardPartPin::ConnectRight, name );
  }
  else
  {
    addPin( i, rect().width()-16, 16+32*(m_numPins-i-1), BreadBoardPartPin::ConnectLeft, name );
  }
}
