//======================================================================
// File:		enabletableitem.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <qpainter.h>
#include <qpixmap.h>

#include <enabletableitem.h>

#include <checkbox.xpm>
#include <checkbox_checked.xpm>

QPixmap *EnableTableItem::checkboxPix = 0;
QPixmap *EnableTableItem::checkboxCheckedPix = 0;

EnableTableItem::EnableTableItem( QTable *table, const QString & text ) :
  QTableItem( table, QTableItem::Never, "Enabled" )
{
  setChecked( false );
  
  setText( text );
  
  if (!checkboxPix)
  {
    checkboxPix = new QPixmap((const char **)checkbox_xpm);
    checkboxCheckedPix = new QPixmap((const char **)checkbox_checked_xpm);
  }
}

EnableTableItem::~EnableTableItem()
{
}
  
void 
EnableTableItem::paint( QPainter *p, const QColorGroup & cg, 
                        const QRect & rect, bool )
{
  const QRect cr( 0, 0, rect.width(), rect.height() );

  p->fillRect( cr, row() & 1 ? cg.base().dark( 105 ) : cg.base() );
  
  p->drawPixmap( 4, (cr.height()-13)/2, 
                 isChecked() ? *checkboxCheckedPix : *checkboxPix );
  
  p->drawText( 20, 0, cr.width()-24, cr.height(), 
               AlignVCenter | AlignLeft, text() );
}
