//======================================================================
// File:		enabletableitem.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef ENABLETABLEITEM_HH
#define ENABLETABLEITEM_HH

#include <qtable.h>

class QPixmap;

class EnableTableItem : public QTableItem
{
public:
  EnableTableItem( QTable *, const QString & text );
  virtual ~EnableTableItem();
  
  void setChecked( bool checked );
  bool isChecked() const { return m_checked; }
  
protected:
  bool m_checked;

  void paint( QPainter *, const QColorGroup &, const QRect &, bool selected );

  static QPixmap *checkboxPix;
  static QPixmap *checkboxCheckedPix;

};

inline void
EnableTableItem::setChecked( bool checked )
{
  m_checked = checked; 
  table()->updateCell( row(), col() );
}

#endif // ENABLETABLEITEM_HH
