//======================================================================
// File:		gotodlg.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <qlineedit.h>
#include <qvalidator.h>
#include <qpushbutton.h>

#include <gotodlg.h>

GotoDlg::GotoDlg( QWidget *parent, const char *name ) :
  UIGotoDlg( parent, name )
{
  QIntValidator *validator = new QIntValidator( 0, 1000000, ui_lineNumber );
  ui_lineNumber->setValidator( validator );
}

GotoDlg::~GotoDlg()
{
}

int 
GotoDlg::lineNumber() const
{
  return ui_lineNumber->text().toInt( 0, 10 );
}

bool
GotoDlg::ok() const
{
  return !ui_lineNumber->text().isEmpty();
}
