//======================================================================
// File:		watchhighlightcondition.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef HIGHLIGHTCONDITION_HH
#define HIGHLIGHTCONDITION_HH

#include <qstring.h>
#include <conditionbase.h>

class PicRAM;

class HighlightCondition : public ConditionBase
{
public:
  enum Mode
  {
    Unknown,
    GreaterThan,
    GreaterOrEqual,
    LessThan,
    LessOrEqual,
    Equal,
    NotEqual,
    And
  };
  HighlightCondition();
  HighlightCondition( PicRAM * );
  ~HighlightCondition();
 
  void setRAM( PicRAM * );
 
  void setPattern( const QString & );
  bool match( int, int ) const;
  
  bool syntaxOk() const;
  
protected:
  PicRAM *m_ram;
  int     m_compareValue;
  int     m_registerAddr;
  Mode    m_mode;
  bool    m_patternWasEmpty;
  bool    m_isIncomplete;
  
  void setMode( Mode mode ) { m_mode = mode; }
  Mode mode() const { return m_mode; }
  
  void setPatternWasEmpty( bool empty ) { m_patternWasEmpty = empty; }
  bool patternWasEmpty() const { return m_patternWasEmpty; }
  
  void setIncomplete( bool on ) { m_isIncomplete = on; }
  bool incomplete() const { return m_isIncomplete; }
  
};

#endif // HIGHLIGHTCONDITION_HH
