//======================================================================
// File:		inspectortip.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <inspectortip.h>
#include <textedit.h>

#include <iostream>

InspectorTip::InspectorTip( QWidget * parent )
  : QToolTip( parent )
{
}

InspectorTip::~InspectorTip()
{
}

void 
InspectorTip::maybeTip( const QPoint &pos )
{
  //std::cerr << "maybe ..." << std::endl;
  if (!parentWidget()->parent()->inherits( "TextEdit" ))
  {
    return;
  }
  
  QString tipText;  
  QRect tipRect = ((TextEdit*)parentWidget()->parent())->tip( pos, tipText );
  
  if (tipText.isNull())
  {
    //std::cerr << "no tip" << std::endl;
    return;
  }
  
  //std::cerr << "show tip " << tipText.latin1() << std::endl;
  tip( tipRect, tipText );
}


