//======================================================================
// File:		instructiontraceviewtable.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef INSTRUCTIONTRACEVIEWTABLE_HH
#define INSTRUCTIONTRACEVIEWTABLE_HH

#include <qscrollview.h>

class QHeader;
class Pic;

class InstructionTraceViewTable : public QScrollView
{
  Q_OBJECT
public:
  InstructionTraceViewTable( QWidget *parent=0, const char *name=0 );
  virtual ~InstructionTraceViewTable();
  
  void setPic( Pic * );
  
public slots:
  void refreshSLOT();
  
signals:
  void showPc( int );

protected:
  Pic     *m_pic;
  int      m_lh;
  QHeader *m_header;
  int      m_current;
  
  void drawContents( QPainter *p, 
                     int clipx, int clipy, int clipw, int cliph );  
  void resizeEvent( QResizeEvent * );
  void contentsMousePressEvent( QMouseEvent *ev );
  void contentsMouseMoveEvent( QMouseEvent *ev );
  void contentsMouseDoubleClickEvent( QMouseEvent *ev );
  
  void setCurrentFromPos( int );
  
};

#endif // INSTRUCTIONTRACEVIEWTABLE_HH
