//======================================================================
// File:		labeltableitem.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <qpainter.h>

#include <labeltableitem.h>

LabelTableItem::LabelTableItem( QTable *table, const QString & label, 
                                int flags, bool bold ) :
  QTableItem( table, QTableItem::Never, label ),
  m_flags( flags ),
  m_bold( bold )
{
}

LabelTableItem::~LabelTableItem()
{
}

void
LabelTableItem::paint( QPainter *p, const QColorGroup & cg, 
                       const QRect & rect, bool )
{
  const QRect cr( 0, 0, rect.width(), rect.height() );

  p->fillRect( cr, row() & 1 ? cg.base().dark( 105 ) : cg.base() );
 
  p->save();
   
  if (m_bold)
  {
    QFont font = p->font();
    font.setBold( true );
    p->setFont( font );
  }
    
  p->drawText( 4, 0, rect.width()-8, rect.height(), 
               m_flags, text() );
  
  p->restore();
}
