//======================================================================
// File:		main.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <qapplication.h>
#include <qdatastream.h>
#include <qdatetime.h>
#include <qfile.h>
#include <qstringlist.h>

#include <pic.h>
#include <mainwindow.h>

#include <stdlib.h>

#include <iostream>

const char *preamble = "\nThis program is free software; you can redistribute it\n"
                       "and/or  modify it  under the terms of  the GNU General\n"
                       "Public  License  version 2 as  published by  the  Free\n"
                       "Software Foundation.\n\n"
                       "This program is  distributed in  the hope that it will\n"
                       "be useful, but  WITHOUT ANY WARRANTY; without even the\n" 
                       "implied warranty  of MERCHANTABILITY  or FITNESS FOR A\n"
                       "PARTICULAR PURPOSE. See the GNU General Public License\n"
                       "for more details.\n\n"
                       "You should  have received  a copy  of the  GNU General\n"
                       "Public License along with this program;  if not, write\n" 
                       "to the Free Software Foundation, Inc., 59 Temple Place,\n"
                       "Suite 330, Boston, MA 02111 USA\n\n"
                       "  YaPIDE is copyright (c) 2004 Matthias Toussaint\n"
                       "  URL:  http://www.mtoussaint.de/yapide.html\n"
                       "  mail: yapide@mtoussaint.de\n";
                       
int main( int argc, char **argv )
{
  QApplication app( argc, argv );
  //QTime timer;
  
  if (argc >= 2)
  {
    QString arg = argv[1];
    
    if (arg == "-?" || arg == "--help")
    {
      std::cout << preamble << std::endl;
      std::cout << "Usage: yapide [-?|--help]         Show this text and exit.\n"
                   "       yapide [-p|--no-preamble]  Don't show preamble.\n"
                << std::endl;

      exit(0);
    }
    else if (arg != "--no-preamble" && arg != "-p")
    {
      std::cout << preamble << std::endl;
    }
  }
  else
  {
    std::cout << preamble << std::endl;
  }
  
  MainWindow mainWin;
  mainWin.show();
  app.setMainWidget( &mainWin );
  
  app.exec();
}
