//======================================================================
// File:		mainwindow.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef MAINWINDOW_HH
#define MAINWINDOW_HH

#include <qmainwindow.h>

class QAction;
class QLabel;
class Workspace;

class MainWindow : public QMainWindow
{
  Q_OBJECT
public:
  MainWindow( QWidget *parent=0, const char *name=0 );
  virtual ~MainWindow();
  
protected:
  Workspace *m_workspace;

  QAction   *m_quitAction;
  
  QAction   *m_freeRunAction;
  QAction   *m_tracingAction;
  QAction   *m_showRAMAction;
  QAction   *m_showROMAction;
  QAction   *m_showCPUAction;
  QAction   *m_showStackAction;
  QAction   *m_showClockAction;
  QAction   *m_showWatchAction;
  QAction   *m_showBreakpointsAction;
  QAction   *m_showEditorAction;
  QAction   *m_showSymbolsAction;
  QAction   *m_showInstructionTraceAction;
  
  QAction   *m_resetPicAction;
  QAction   *m_brownoutPicAction;
  QAction   *m_runPicAction;
  QAction   *m_animatePicAction;
  QAction   *m_stepPicAction;
  QAction   *m_overPicAction;
  QAction   *m_finishCallPicAction;
  QAction   *m_stopPicAction;
  
  QAction   *m_aboutQtAction;
  QAction   *m_aboutAction;
  QAction   *m_whatsThisAction;
  
  QAction   *m_newFileAction;
  QAction   *m_openFileAction;
  QAction   *m_saveFileAction;
  QAction   *m_saveFileAsAction;
  QAction   *m_closeFileAction;
  QAction   *m_makeAction;
  
  QAction   *m_undoAction;
  QAction   *m_redoAction;
  QAction   *m_cutAction;
  QAction   *m_copyAction;
  QAction   *m_pasteAction;
  QAction   *m_selectAllAction;
  QAction   *m_upperAction;
  QAction   *m_lowerAction;
  
  QAction   *m_findFileAction;
  QAction   *m_findAction;
  QAction   *m_findAgainAction;
  QAction   *m_replaceAction;
  QAction   *m_replaceAgainAction;
  QAction   *m_gotoLineAction;
  QAction   *m_gotoSelectionAction;
  
  int m_frequencyTimer;
  
  QLabel *m_status;
  
  void timerEvent( QTimerEvent * );
  
  void createActions();
  void createMenu();
  void createToolBars();
  
protected slots:
  void updateMenusSLOT( bool );
  void quitSLOT();
  void aboutSLOT();
  void aboutQtSLOT();
  void enterWhatsThisModeSLOT();
  
};

#endif // MAINWINDOW_HH
