//======================================================================
// File:		optionregister.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef OPTIONREGISTER_HH
#define OPTIONREGISTER_HH

#include <picregister.h>

class OPTIONRegister : public PicRegister
{
public:
  OPTIONRegister();
  ~OPTIONRegister();
  
  int prescaleTimer0() const { return m_prescaleTimer0; }
  
  void setBit( int bit );
  void clearBit( int bit );
  void setValue( int value );
  
  bool t0cs() const { return (m_value & 0x20); }
  
protected:
  int m_prescaleTimer0;

  void setPrescaleTimer0();
  
};

inline void
OPTIONRegister::setPrescaleTimer0()
{
  if (m_value & 0x08)
  {
    m_prescaleTimer0 = 1;
  }
  else
  {
    switch (m_value & 0x07)
    {
    case 0:
      m_prescaleTimer0 = 2;
      break;
    case 1:
      m_prescaleTimer0 = 4;
      break;
    case 2:
      m_prescaleTimer0 = 8;
      break;
    case 3:
      m_prescaleTimer0 = 16;
      break;
    case 4:
      m_prescaleTimer0 = 32;
      break;
    case 5:
      m_prescaleTimer0 = 64;
      break;
    case 6:
      m_prescaleTimer0 = 128;
      break;
    case 7:
      m_prescaleTimer0 = 256;
      break;
    }
  }
}

inline void
OPTIONRegister::setBit( int bit )
{
  PicRegister::setBit( bit );
  
  setPrescaleTimer0();
}

inline void
OPTIONRegister::clearBit( int bit )
{
  PicRegister::clearBit( bit );
  
  setPrescaleTimer0();
}

inline void
OPTIONRegister::setValue( int value )
{
  PicRegister::setValue( value );
  
  setPrescaleTimer0();
}

#endif // OPTIONREGISTER_HH
