//======================================================================
// File:		outputitem.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <qpainter.h>

#include <outputitem.h>

#include <iostream>

OutputItem::OutputItem( const QString & text, Mode mode, QListBox *list ) :
  QListBoxText( list ),
  m_mode( mode )
{
  setText( text );
}

OutputItem::~OutputItem()
{
}

void
OutputItem::paint( QPainter *p )
{
  p->save();
  
  if (isSelected())
  {
    p->setPen( listBox()->colorGroup().highlightedText() );
  }
  else
  {
    switch (m_mode)
    {
    case Message:
      break;
    case Warning:
      p->setPen( Qt::blue );
      break;
    case Error:
      p->setPen( Qt::red );
      break;
    }
  }
  
  p->drawText( 0, 0, width( listBox() ), height( listBox() ), 
               Qt::AlignLeft | Qt::AlignVCenter, text() );  
  
  p->restore();
}
