//======================================================================
// File:		pclregister.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef PCLREGISTER_HH
#define PCLREGISTER_HH

#include <picram.h>
#include <picregister.h>
#include <pic.h>

class PCLRegister : public PicRegister
{
public:
  PCLRegister( Pic *pic, int *pc );
  ~PCLRegister();
  
  void setBit( int bit );
  void clearBit( int bit );
  void setValue( int value );
  
protected:
  Pic *m_pic;
  int *m_pc;
  
  void setPc();
  
};
 
inline void
PCLRegister::setPc()
{
  *m_pc = m_pic->pcFromPCL();
  
  m_pic->flushInstructionPipeline();
}

inline void
PCLRegister::setBit( int bit )
{
  PicRegister::setBit( bit );
  
  setPc();
}

inline void
PCLRegister::clearBit( int bit )
{
  PicRegister::clearBit( bit );
  
  setPc();
}

inline void
PCLRegister::setValue( int value )
{
  PicRegister::setValue( value );
  
  setPc();
}

#endif // PCLREGISTER_HH
