//======================================================================
// File:		picregistertableitem.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef PICREGISTERTABLEITEM_HH
#define PICREGISTERTABLEITEM_HH

#include <hextableitem.h>

class PicRegister;

class PicRegisterTableItem : public HexTableItem
{
public:
  PicRegisterTableItem( QTable *, PicRegister *, bool shadow=false );
  virtual ~PicRegisterTableItem();
  
  void setSpecialColor( const QColor & color );
  void resetSpecialColor();
  bool isSpecialColor( const QColor & color ) const 
      { return (color==m_color) && m_colorized; }
  bool isSpecialColor() const { return m_colorized; }
  bool isNullRegister() const { return m_nullReg; }
  
  PicRegister *picRegister() const { return m_reg; }
 
protected:
  QColor       m_color;
  bool         m_colorized;
  bool         m_nullReg;
  QColor       m_normalColor;
  
  virtual void paint( QPainter *, const QColorGroup &, 
                      const QRect &, bool selected );
  
};

#endif // PICREGISTERTABLEITEM_HH
