//======================================================================
// File:		picstack.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <picstack.h>

PicStack::PicStack( int size ) :
  m_size( size )
{
  m_stack = new unsigned [m_size];
  m_call = new unsigned [m_size];
  m_cyclesAtCall = new unsigned long [m_size];
  m_pcAtCall = new int [m_size];
  
  // this implies that the size is power of two
  // 
  m_mask = size-1;
  
  reset();
}

PicStack::~PicStack()
{
  delete [] m_stack;
  delete [] m_call;
  delete [] m_cyclesAtCall;
  delete [] m_pcAtCall;
}

void
PicStack::reset()
{
  m_stackPointer = 0;
  
  for (int i=0; i<m_size; ++i) m_stack[i] = 0;
}



  
    
