//======================================================================
// File:		pictimer16.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <picregister.h>
#include <pictimer16.h>

#include <iostream>

PicTimer16::PicTimer16( const QString & name, PicRegister *conReg, int conBit ) :
  PicTimer( name ),
  m_conReg( conReg ),
  m_conBit( conBit )
{
  reset();
}

PicTimer16::~PicTimer16()
{
}

void
PicTimer16::reset()
{
  m_prescale = 1;
  m_prescaleCnt = 1;
  m_value = 0;
}

void
PicTimer16::setValue( Q_UINT16 value )
{
  m_value = value;
  setRegisterInternal();
}

void
PicTimer16::setRegister( PicRegister *lo, PicRegister *hi )
{
  m_loByte = lo;
  m_hiByte = hi;
}

void
PicTimer16::clockTick()
{
  if (!m_conReg->bitSetPic( m_conBit )) return;
  
  if (--m_prescaleCnt <= 0)
  {
    m_value++;
    m_prescaleCnt = m_prescale;
  }
  
  if (m_value > 0xffff)
  {
    m_value = 0;
    // rollover
  }
  
  setRegisterInternal();
}
