//======================================================================
// File:		pictimer16.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef PICTIMER16_HH
#define PICTIMER16_HH

#include <pictimer.h>

class PicTimer16 : public PicTimer
{
public:
  PicTimer16( const QString &, PicRegister *conReg, int bit );
  virtual ~PicTimer16();
  
  int loByte() const;
  int hiByte() const;
  int value() const { return m_value; }
  void setValue( Q_UINT16 );
  void reset();
  void setPrescale( int ps ) { m_prescale = ps; }
  virtual void clockTick();
  void setRegister( PicRegister *lo, PicRegister *hi );
  
protected:
  QString      m_name;
  int          m_prescale;
  int          m_prescaleCnt;
  int          m_value;
  PicRegister *m_loByte;
  PicRegister *m_hiByte;
  PicRegister *m_conReg;
  int          m_conBit;
  
  void setRegisterInternal();
  
};

inline int 
PicTimer16::loByte() const
{
  return m_loByte->valuePic();
}

inline int 
PicTimer16::hiByte() const
{
  return m_hiByte->valuePic();
}

inline void
PicTimer16::setRegisterInternal()
{
  m_loByte->setValuePic( m_value );
  m_hiByte->setValuePic( m_value >> 8 );
}

#endif // PICTIMER16_HH
