//======================================================================
// File:		pictimer8.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <picregister.h>
#include <optionregister.h>
#include <pictimer8.h>

#include <iostream>

PicTimer8::PicTimer8( const QString & name, OPTIONRegister *optionReg ) :
  PicTimer( name ),
  m_optionReg( optionReg )
{
  reset();
}

PicTimer8::~PicTimer8()
{
}

void
PicTimer8::reset()
{
  m_prescaleCnt = m_optionReg->prescaleTimer0();
  m_value = 0;
}

void
PicTimer8::setRegister( PicRegister *reg )
{
  m_reg = reg;
}

void
PicTimer8::setValue( Q_UINT8 value )
{
  m_value = value;
  setRegisterInternal();
}

void
PicTimer8::clockTick()
{
  if (m_optionReg->t0cs()) return;
  
  if (--m_prescaleCnt <= 0)
  {
    m_value++;
    m_prescaleCnt = m_optionReg->prescaleTimer0();
  }
  
  if (m_value > 0xff)
  {
    m_value = 0;
    // rollover
  }
  
  setRegisterInternal();
}

