//======================================================================
// File:		pictimer8.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef PICTIMER8_HH
#define PICTIMER8_HH

#include <pictimer.h>

class OPTIONRegister;

class PicTimer8 : public PicTimer
{
public:
  PicTimer8( const QString &, OPTIONRegister *optionReg );
  virtual ~PicTimer8();
  
  int value() const { return m_value; }
  void setValue( Q_UINT8 );
  void reset();
  virtual void clockTick();
  void setRegister( PicRegister *reg );
  
protected:
  QString         m_name;
  int             m_prescaleCnt;
  int             m_value;
  PicRegister    *m_reg;
  OPTIONRegister *m_optionReg;
  
  void setRegisterInternal();
  
};

inline void
PicTimer8::setRegisterInternal()
{
  m_reg->setValuePic( m_value );
}

#endif // PICTIMER8_HH
