//======================================================================
// File:		registertracebuffer.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef REGISTERTRACEBUFFER_HH
#define REGISTERTRACEBUFFER_HH

#include <qglobal.h>
#include <tracebuffer.h>
#include <picregister.h>

class RegisterTraceBuffer : public TraceBuffer
{
public:
  RegisterTraceBuffer( PicRegister * );
  ~RegisterTraceBuffer();

  void add( unsigned );
  int value( int pos ) const;  
  unsigned cycles( int pos ) const;  
  PicRegister *reg() const { return m_reg; }
  
protected:
  PicRegister   *m_reg;
  unsigned      *m_cycles;
  int           *m_value;
  
};

inline void
RegisterTraceBuffer::add( unsigned cycles )
{
  m_cycles[m_curPointer]  = cycles;
  m_value[m_curPointer++] = m_reg->valuePic();
  m_curPointer &= 0xfff;
  
  if (m_length < 0xfff) m_length++;
}

inline int
RegisterTraceBuffer::value( int pos ) const
{
  return m_value[offset(pos)];
}

inline unsigned 
RegisterTraceBuffer::cycles( int pos ) const
{
  return m_cycles[offset(pos)];
}

#endif // REGISTERTRACEBUFFER_HH
