//======================================================================
// File:		replacedlg.cpp
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#include <qcombobox.h>
#include <qcheckbox.h>
#include <qpushbutton.h>

#include <replacedlg.h>

ReplaceDlg::ReplaceDlg( QWidget *parent, const char *name ) :
  UIReplaceDlg( parent, name )
{
  connect( ui_replace, SIGNAL( clicked() ),
           this, SIGNAL( replace() ));
}

ReplaceDlg::~ReplaceDlg()
{
}

bool 
ReplaceDlg::caseSensitive() const
{
  return ui_caseSensitive->isChecked();
}

bool 
ReplaceDlg::wordsOnly() const
{
  return ui_wordsOnly->isChecked();
}

bool 
ReplaceDlg::forward() const
{
  return !ui_backward->isChecked();
}

bool 
ReplaceDlg::backward() const
{
  return ui_backward->isChecked();
}

bool 
ReplaceDlg::keepDialog() const
{
  return ui_keepDialog->isChecked();
}

QString 
ReplaceDlg::findText() const
{
  return ui_find->currentText();
}

QString 
ReplaceDlg::replaceText() const
{
  return ui_replaceWith->currentText();
}

