//======================================================================
// File:		sevesegmentdisplay.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef SEVENSEGMENTDISPLAY_HH
#define SEVENSEGMENTDISPLAY_HH

#include <qrect.h>

#include <breadboardpart.h>

class QPainter;
class PicRegister;

class SevenSegmentDisplay : public BreadBoardPart
{
public:
  SevenSegmentDisplay( const QString & name=QString::null );
  virtual ~SevenSegmentDisplay();

  virtual void paint( QPainter * );
  void assignRegister( int, PicRegister *, int );
  
protected:
  PicRegister *m_register[8];
  int          m_bit[8];
  int          m_segLength;
  int          m_segWidth;
  int          m_value[8];
  QColor       m_segmentColor;
  
  QColor segmentColor( int );
    
  void timerEvent( QTimerEvent * );

};

#endif // SEVENSEGMENTDISPLAY_HH
