TEMPLATE        = app
CONFIG          = qt release warn_on thread 
INCLUDEPATH     = . xpm 
MOC_DIR         = tmp
OBJECTS_DIR     = tmp
DEPENDPATH      = . 
TARGET          = yapide

QMAKE_CFLAGS_RELEASE -= -O2
QMAKE_CXXFLAGS_RELEASE -= -O2
QMAKE_CFLAGS -= -O2
QMAKE_CXXFLAGS -= -O2

release {
  contains( QMAKE_CC, gcc ) {
    message( "Adding release optimizations for gcc" )
    QMAKE_CFLAGS   += -O3 -finline-functions -fexpensive-optimizations \
                      -fstrict-aliasing -fomit-frame-pointer 
    QMAKE_CXXFLAGS += -O3 -finline-functions -fexpensive-optimizations \
                      -fstrict-aliasing -fomit-frame-pointer
  }
}

debug {
  message( "Compiling for debug" )
}
    
CPU_YAPIDE = $$system( echo $CPU )

contains( CPU_YAPIDE, i686 ) {
	message( "Configuring for Pentium Pro" )
	QMAKE_CFLAGS   += -march=i686
	QMAKE_CXXFLAGS += -march=i686
}

contains( CPU_YAPIDE, Athlon ) {
  message( "Configuring for Athlon" )
  QMAKE_CFLAGS   += -march=athlon
  QMAKE_CXXFLAGS += -march=athlon
}

contains( CPU_YAPIDE, x86_64 ) {
  message( "Configuring for Athlon64" )
  QMAKE_CFLAGS   += -march=k8
  QMAKE_CXXFLAGS += -march=k8
}

HEADERS   = \
            xpm/animation.xpm \
            xpm/breakpoint.xpm \
            xpm/brownout.xpm \
            xpm/clock.xpm \
            xpm/close.xpm \
            xpm/copy.xpm \
            xpm/cpu.xpm \
            xpm/cut.xpm \
            xpm/editor.xpm \
            xpm/save_as.xpm \
            xpm/new.xpm \
            xpm/open.xpm \
            xpm/paste.xpm \
            xpm/quit.xpm \
            xpm/ram.xpm \
            xpm/redo.xpm \
            xpm/reset.xpm \
            xpm/rom.xpm \
            xpm/run.xpm \
            xpm/save.xpm \
            xpm/stack.xpm \
            xpm/stop_after_command.xpm \
            xpm/stop_after_procedure.xpm \
            xpm/stop.xpm \
            xpm/undo.xpm \
            xpm/yapide_logo.xpm \
            xpm/yapide_logo_small.xpm \
            bittableitem.h \
            breadboard.h \
            watchbreaktableitem.h \
            instructiontraceviewtable.h \
            instructiontraceview.h \
            breaktableitem.h \
            breadboardpart.h \
            breadboardpartpin.h \
            breadboardview.h \
            breakpoint.h \
            breakcondition.h \
            breakconditionedit.h \
            pictableitem.h \
            clockview.h \
            cpuview.h \
            dectableitem.h \
            dil.h \
            colorbutton.h \
            disass.h \
            editor.h \
            bintableitem.h \
            enabletableitem.h \
            hextableitem.h \
            outputitem.h \
            registertracebuffer.h \
            registertrace.h \
            instructiontracebuffer.h \
            tracebuffer.h \
            labeltableitem.h \
            lowpassdouble.h \
            mainwindow.h \
            matrixdisplay_7x5.h \
            nullregister.h \
            statusregister.h \
            optionregister.h \
            indfregister.h \
            pclregister.h \
            pic.h \
            pic16f628.h \
            picram.h \
            picregister.h \
            picregistertableitem.h \
            picrom.h \
            picstack.h \
            pictimer.h \
            pictimer0.h \
            pictimer8.h \
            pictimer16.h \
            picsyntaxhighlighter.h \
            ramview.h \
            romviewtable.h \
            highlightcondition.h \
            romview.h \
            sevensegmentdisplay.h \
            stackview.h \
            watchview.h \
            textedit.h \
            breakpointview.h \
            workspace.h \
            conditionbase.h \
            watchcondition.h \
            watchconditionedit.h \
            cod.h \
            finddlg.h \
            replacedlg.h \
            symbol.h \
            symboltable.h \
            symbolview.h \
            symbolviewitem.h \
            stringconversion.h \
            inspectortip.h \
            gotodlg.h

FORMS = \
            uiabout.ui \
            uibreadboardview.ui \
            uibreakpointview.ui \
            uiclockview.ui \
            uicpuview.ui \
            uieditor.ui \
            uifinddlg.ui \
            uireplacedlg.ui \
            uigotodlg.ui \
            uiprefdlg.ui \
            uiramprefs.ui \
            uiramview.ui \
            uiromprefs.ui \
            uiromview.ui \
            uistackview.ui \
            uisymbolview.ui \
            uiinstructiontraceview.ui \
            uiwatchview.ui 

SOURCES   = \
            bintableitem.cpp \
            bittableitem.cpp \
            breadboard.cpp \
            breadboardpart.cpp \
            breadboardpartpin.cpp \
            breadboardview.cpp \
            breakcondition.cpp \
            breakconditionedit.cpp \
            outputitem.cpp \
            instructiontraceviewtable.cpp \
            instructiontraceview.cpp \
            breakpoint.cpp \
            breakpointview.cpp \
            breaktableitem.cpp \
            clockview.cpp \
            cod.cpp \
            colorbutton.cpp \
            conditionbase.cpp \
            cpuview.cpp \
            dectableitem.cpp \
            dil.cpp \
            disass.cpp \
            editor.cpp \
            enabletableitem.cpp \
            finddlg.cpp \
            replacedlg.cpp \
            gotodlg.cpp \
            hextableitem.cpp \
            highlightcondition.cpp \
            labeltableitem.cpp \
            lowpassdouble.cpp \
            main.cpp \
            mainwindow.cpp \
            matrixdisplay_7x5.cpp \
            nullregister.cpp \
            optionregister.cpp \
            statusregister.cpp \
            indfregister.cpp \
            pclregister.cpp \
            pic.cpp \
            textedit.cpp \
            pic16f628.cpp \
            picram.cpp \
            picregister.cpp \
            picregistertableitem.cpp \
            picrom.cpp \
            picstack.cpp \
            picsyntaxhighlighter.cpp \
            pictableitem.cpp \
            pictimer.cpp \
            pictimer16.cpp \
            pictimer8.cpp \
            pictimer0.cpp \
            ramview.cpp \
            romview.cpp \
            romviewtable.cpp \
            registertracebuffer.cpp \
            registertrace.cpp \
            instructiontracebuffer.cpp \
            tracebuffer.cpp \
            sevensegmentdisplay.cpp \
            stackview.cpp \
            stringconversion.cpp \
            symbol.cpp \
            symboltable.cpp \
            symbolview.cpp \
            symbolviewitem.cpp \
            watchbreaktableitem.cpp \
            watchcondition.cpp \
            watchconditionedit.cpp \
            watchview.cpp \
            inspectortip.cpp \
            workspace.cpp

VERSION   = 0.1
DESTDIR   = ../bin
