//======================================================================
// File:		statusregister.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef STATUSREGISTER_HH
#define STATUSREGISTER_HH

#include <picregister.h>

class STATUSRegister : public PicRegister
{
public:
  STATUSRegister();
  ~STATUSRegister();
  
  int bank() const { return m_bank; }
  
  void setBit( int bit );
  void clearBit( int bit );
  void setValue( int value );
  
protected:
  int m_bank;

  void setBank();
  
};

inline void
STATUSRegister::setBank()
{
  m_bank = (m_value >> 5) & 0x03;
}

inline void
STATUSRegister::setBit( int bit )
{
  PicRegister::setBit( bit );
  
  setBank();
}

inline void
STATUSRegister::clearBit( int bit )
{
  PicRegister::clearBit( bit );
  
  setBank();
}

inline void
STATUSRegister::setValue( int value )
{
  PicRegister::setValue( value );
  
  setBank();
}

#endif // STATUSREGISTER_HH
