//======================================================================
// File:		stringconversion.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef STRINGCONVERSION_HH
#define STRINGCONVERSION_HH

#include <qstring.h>

class StringConversion
{
public:
  static QString binString( int );
  static QString hexString( int );
  static QString decString( int );
  static QString freqString( double );
  static QString freqString_g( double );
  
protected:
  static bool     s_initialized;
  static QString  s_binString[256];
  static QString  s_hexString[256];
  static QString  s_decString[256];
  static char    *s_unitString[3];
  
  static void initStrings();
  
};

#endif // STRINGCONVERSION_HH
