//======================================================================
// File:		wtachview.h
// Author:	Matthias Toussaint
// Created:	Mon Jul 26 23:08:00 CET 2004
//----------------------------------------------------------------------
// Permission to use, copy, modify, and distribute this software and its
// documentation  for any  purpose and  without fee is  hereby  granted,
// provided  that below copyright notice appear  in all copies  and that
// both  that  copyright  notice and  this permission  notice  appear in
// supporting documentation.
// 
// This  file is  provided AS IS  with no  warranties  of any kind.  The
// author shall  have no liability  with respect  to the infringement of
// copyrights, trade  secrets  or any patents by  this file  or any part
// thereof.  In no event will the author be liable  for any lost revenue
// or profits or other special, indirect and consequential damages.
//----------------------------------------------------------------------
// (c) 2004 Matthias Toussaint
//======================================================================

#ifndef WATCHVIEW_HH
#define WATCHVIEW_HH

#include <qptrlist.h>

#include <uiwatchview.h>
#include <picregister.h>

class Pic;
class WatchCondition;

class WatchObject
{
public:
  WatchObject( PicRegister *reg, int row );
  ~WatchObject();
  
  PicRegister *reg() const { return m_reg; }
  int row() const { return m_row; }
  WatchCondition *watch() { return m_watch; }
  
protected:
  PicRegister    *m_reg;
  int             m_row;
  WatchCondition *m_watch;
  
};

typedef QPtrList<WatchObject> WatchObjectList;
typedef QPtrListIterator<WatchObject> WatchObjectListIterator;

class WatchView : public UIWatchView
{
  Q_OBJECT
public:
  WatchView( QWidget *parent=0, const char *name=0 );
  virtual ~WatchView();

  void setPic( Pic * );

  void setEditable( bool );
  
signals:
  void updateViews();

public slots:
  void refreshSLOT();
  void addWatchSLOT( PicRegister *reg );
  void removeWatchSLOT( PicRegister *reg );
  void show();
  
protected slots:
  void valueChangedSLOT( int row, int col );
  void clickedSLOT( int row, int col, int button, const QPoint & mousePos );
  
protected:
  Pic             *m_pic;
  WatchObjectList  m_watches;
  
  WatchObject *findObjectForRow( int row );
  
};

#endif // WATCHVIEW_HH
